## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 16;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

# Generated by go2rpm 1.8.2
%bcond_without check

# https://gitlab.com/gitlab-org/cli
%global goipath         gitlab.com/gitlab-org/cli
%global forgeurl        https://gitlab.com/gitlab-org/cli
Version:                1.35.0

%global repo            cli
%global archivename     %{repo}-%{version}
%global archiveext      tar.bz2
%global archiveurl      %{forgeurl}/-/archive/v%{version}/%{repo}-v%{version}.%{archiveext}
%global topdir          %{repo}-v%{version}
%global extractdir      %{repo}-v%{version}

%gometa -f

%global goname glab

%global common_description %{expand:
A GitLab CLI tool bringing GitLab to your command line.}

%global golicenses      LICENSE
%global godocs          README.md

Name:           %{goname}
Release:        %autorelease
Summary:        A GitLab CLI tool bringing GitLab to your command line

License:        MIT
URL:            %{gourl}
Source:         %{gosource}

BuildRequires:  git-core
BuildRequires:  sed

Requires:       git-core

%description %{common_description}

%gopkg

%prep
%goprep

%generate_buildrequires
%go_generate_buildrequires

%build
export LDFLAGS="-X main.version=%{version}  \
                -X main.buildDate=$(date -d "@${SOURCE_DATE_EPOCH}" +%Y-%m-%d) \
                -X main.platform=Fedora
                -X main.debugMode=false"
for cmd in cmd/%{name} cmd/gen-docs; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done

# Generate manpages
%{gobuilddir}/bin/gen-docs --manpage --path ./share/man/man1

# Generate shell completions
%{gobuilddir}/bin/%{name} completion -s bash > %{name}.bash
%{gobuilddir}/bin/%{name} completion -s fish > %{name}.fish
%{gobuilddir}/bin/%{name} completion -s zsh  > %{name}.zsh

%install
%gopkginstall
# We are deliberately excluding cmd/gen-docs. It is only needed for building.
install -Dpm 0755 %{gobuilddir}/bin/%{name} -t %{buildroot}%{_bindir}/

# Install manpages
install -Dpm 0644 ./share/man/man1/%{name}*.1 -t %{buildroot}%{_mandir}/man1/

# Install shell completions
install -Dpm 0644 %{name}.bash %{buildroot}%{bash_completions_dir}/%{name}
install -Dpm 0644 %{name}.fish %{buildroot}%{fish_completions_dir}/%{name}.fish
install -Dpm 0644 %{name}.zsh  %{buildroot}%{zsh_completions_dir}/_%{name}

%if %{with check}
%check
export NO_COLOR=1
git init
git config --global --add safe.directory $(pwd)

for test in "Test_printError" "TestAliasDelete" "Test_statusRun" \
            "Test_statusRun_noHostnameSpecified" "Test_statusRun_noInstance" \
            "TestNewCmdCompletion" "TestNewCheckUpdateCmd" "Test_deleteRun" \
            "Test_setRun_project" "Test_setRun_group" "Test_updateRun_project" \
            "Test_updateRun_group" "TestGetRemoteURL" "Test_isColorEnabled" \
            "Test_makeColorFunc" "Test_HelperFunctions" \
; do
awk -i inplace '/^func.*'"$test"'\(/ { print; print "\tt.Skip(\"disabled failing test\")"; next}1' $(grep -rl $test)
done
%gocheck -d gitlab.com/gitlab-org/cli/commands \
         -d gitlab.com/gitlab-org/cli/commands/auth/login \
         -d gitlab.com/gitlab-org/cli/commands/ci/lint \
         -d gitlab.com/gitlab-org/cli/commands/ci/trace \
         -d gitlab.com/gitlab-org/cli/commands/issuable/view \
         -d gitlab.com/gitlab-org/cli/commands/issue/delete \
         -d gitlab.com/gitlab-org/cli/commands/mr \
         -d gitlab.com/gitlab-org/cli/commands/mr/delete \
         -d gitlab.com/gitlab-org/cli/commands/mr/note \
         -d gitlab.com/gitlab-org/cli/commands/mr/subscribe \
         -d gitlab.com/gitlab-org/cli/commands/mr/unsubscribe \
         -d gitlab.com/gitlab-org/cli/commands/mr/update \
         -d gitlab.com/gitlab-org/cli/commands/mr/view \
         -d gitlab.com/gitlab-org/cli/commands/project/archive \
         -d gitlab.com/gitlab-org/cli/commands/project/clone \
         -d gitlab.com/gitlab-org/cli/commands/project/create \
         -d gitlab.com/gitlab-org/cli/commands/schedule/list \
         -d gitlab.com/gitlab-org/cli/commands/schedule/run
%endif

%files
%license LICENSE
%doc README.md
%{_bindir}/*
%{_mandir}/man1/%{name}*1*
%{bash_completions_dir}/%{name}
%{fish_completions_dir}/%{name}.fish
%{zsh_completions_dir}/_%{name}

%gopkgfiles

%changelog
* Fri Nov 17 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-16
- Update to 1.35.0 - Closes rhbz#2248170

* Tue Oct 24 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-15
- Update to 1.34.0 - Closes rhbz#2245759

* Wed Aug 23 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-14
- Update to 1.32.0 - Closes rhbz#2233224

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> None-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Wed Jun 28 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-12
- Update to 1.31.0 - Closes rhbz#2208685

* Sat May 20 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-11
- Update to 1.30.0 - Closes rhbz#2208685

* Fri May 12 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-10
- Update to 1.29.4 - Closes rhbz#2193211

* Fri Apr 21 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-9
- Update to 1.28.1 - Closes rhbz#2186556

* Thu Apr 13 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-8
- Update to 1.28.0 - Closes rhbz#2186556

* Thu Apr 13 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-7
- Update to 1.27.1 - Closes rhbz#2184809

* Sat Apr 01 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-6
- Update to 1.27.0 - Closes rhbz#2183570

* Sat Mar 11 2023 Fabio Valentini <decathorpe@gmail.com> None-5
- Rebuild for https://pagure.io/releng/issue/11327

* Fri Mar 10 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-4
- Update to 1.26.0 - Closes rhbz#2177308

* Thu Feb 09 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-3
- Update to 1.25.3

* Wed Feb 08 2023 Mikel Olasagasti Uranga <mikel@olasagasti.info> None-2
- Initial package - Closes rhbz#2159522
